<template>
    <div id="person-form">
        <hr class="my-3">
        <form @submit.prevent="handleSubmit">
            <h4 class="font-weight-normal">Person</h4>
            <!--name-->
            <div class="form-group">
                <label for="name">Name</label>
                <input @focus="resetErrors" type="text" v-model="person.name" id="name" class="form-control"
                       autocomplete="off" required>
                <small class="text-muted">Required</small>
            </div>
            <div class="form-group">
                <div class="row">
                    <div class="col">
                        <!--born-->
                        <label for="born">Born</label>
                        <input @focus="resetErrors" type="date" v-model="person.born" id="born" class="form-control">
                        <small class="text-muted">Optional</small>
                    </div>
                    <div class="col">
                        <!--died-->
                        <label for="died">Died</label>
                        <input @focus="resetErrors" type="date" v-model="person.died" id="died" class="form-control">
                        <small class="text-muted">Optional</small>
                    </div>
                </div>
            </div>
            <button class="btn btn-primary">
                <span class="fas fa-plus"/> Insert
            </button>
            <p v-if="errors.success" class="bg-success text-white mt-4 px-2">Person inserted</p>
            <p v-else-if="errors.fail" class="bg-danger text-white mt-4 px-2">Something went wrong</p>
            <p v-else-if="errors.invalid" class="bg-danger text-white mt-4 px-2">Required input missing</p>
        </form>
    </div>
</template>

<script>
    export default {
        name: "person-form",
        data() {
            return {
                person: {
                    name: '',
                    born: '',
                    died: '',
                },
                errors: {
                    success: false,
                    fail: false,
                    invalid: false,
                },
            }
        },
        methods: {
            async handleSubmit() {
                try {
                    this.person.name = this.person.name.trim();
                    if (!this.person.name) {
                        this.errors.invalid = true;
                        return;
                    }
                    if (!this.person.born.trim()) {
                        this.person.born = null;
                    }
                    if (!this.person.died.trim()) {
                        this.person.died = null;
                    }
                    const response = await fetch(`http://localhost:8081/api/people`, {
                        method: 'POST',
                        body: JSON.stringify(this.person),
                        headers: {'Content-type': 'application/json; charset=UTF-8'},
                    });
                    this.errors.success = await response.json();
                    if (!this.errors.success) {
                        this.errors.fail = true
                    } else {
                        this.resetInput()
                    }
                } catch (e) {
                    console.error(e);
                    this.errors.fail = true;
                }
            },
            resetErrors() {
                this.errors.fail = false;
                this.errors.success = false;
                this.errors.invalid = false;
            },
            resetInput() {
                this.person.name = '';
                this.person.born = '';
                this.person.died = '';
            },
        }
    }
</script>

<style scoped>
</style>